
/* Jean-Claude Berger, 2009.

   Videur de mmoire JFreeMem

   L'ide est d'allouer de la mmoire puis de la librer ensuite pour pouvoir lancer 
   les machines virtuelles des cours Microsoft parce qu'en s'allouant beaucoup de mmoire, 
   on force le cache  se rtrcir. Du coup  la sortie du programme, on a le temps de lancer 
   la machine virtuelle avant que Vista ne fasse de nouveau grandir le cache. C'est le principe
   du pousse toi que je m'y mette.

   Je procde par rcursion pour essayer d'obtenir le plus de mmoire possible. Donc, j'alloue
   un bout de mmoire, que je remplis, puis je retente un bout de mmoire supplmentaire et ainsi 
   de suite jusqu' ce que Windows ne veuille plus. Comme d'une part je veux pouvoir lancer le 
   programme sans lui passer d'argument (par un simple double clic) et que d'autre part, il faut
   bien librer la mmoire en repassant le pointeur sur le bloc obtenu par malloc, le plus 
   simple est de faire une rcusion donc chaque niveau va conserver ses variables.

   Pour faire joli, j'ai aussi une variable globale (iteration) qui me permettra d'afficher
   le nombre d'itrations ralises et un flag boolen (boolAlloueAuMoinsUneFois) qui me 
   permet d'afficher un message aucas o je n'arriverai pas  allouer de la mmoire 
   ne serait-ce qu'une fois.

   Il est ncessaire de remplir le bloc mmoire allou car sinon l'allocation en elle-mme
   ne fait rien, Windows ne librant pas de ressources.

*/

#include "stdafx.h"
#include <malloc.h>
#include <stdlib.h>
#include <stdio.h>

#define TAILLE 100000000    // 100 Mo

void alloue(unsigned __int32 & iteration, bool & boolAlloueAuMoinsUneFois)
/*
	S'appelle rcursivement jusqu' ce qu'elle ne puisse plus obtenir de mmoire.

	Reoit deux variables par rfrence pour que chaque rcursion puisse afficher son niveau d'appel ou que
	l'on puisse prvenir la procdure appelante que cela n'a pas march du tout.

*/
{
	char				*pchar_chaine;
	unsigned __int32	i;

	pchar_chaine = (char *)malloc(TAILLE * sizeof(char));  // Allocation
	
   if( pchar_chaine != NULL )   // Si l'allocation a march
   {
	   printf( "Memory allocated so far %d bytes in %d iteration(s).\n", TAILLE * sizeof(char) * iteration, iteration );
	   boolAlloueAuMoinsUneFois = 1;  // Cela a march au moins une fois

       // Il faut crire dans la mmoire alloue sinon Windows ne ragit pas.
	   for (i = 0; i < (TAILLE * sizeof(char)) ; i += sizeof(char)) {
			*(pchar_chaine + i) = 'A';
	   }
	  iteration++;
	  alloue(iteration, boolAlloueAuMoinsUneFois);  // Rcursion

      free( pchar_chaine );
 	  iteration--;  // Avant de l'imprimer parce qu'on l'a incrmente avant de tenter la dernire allocation qui 
					// n'a pas march (puisque l'on sort de la rcursion)
      printf( "Memory freed for iteration %d.\n", iteration );
  }
   // Si l'allocation n'a pas march, on ne fait rien.
}

int _tmain(int argc, _TCHAR* argv[])
{
	unsigned __int32 iteration = 1;    
	bool			 boolAlloueAuMoinsUneFois = 0;

	printf ("JFreeMem, Jean-Claude Berger's (www.jcberger.com) dumb memory liberator utility.\n");
	alloue(iteration, boolAlloueAuMoinsUneFois);

	if (boolAlloueAuMoinsUneFois == 0)  {
      printf( "Could not allocate memory.\n" );
	  return 1;
   }

	return 0;
}


